﻿//--------------------------------------------------------------------------
// 
//  Copyright (c) Microsoft Corporation.  All rights reserved. 
// 
//  File: Raytracer.cs
//
//--------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Threading;
using System.Threading.Tasks;

namespace Microsoft.ParallelComputingPlatform.ParallelExtensions.Samples
{
    public abstract class ParallelRayTracerBase : RayTracerBase
    {

        public ParallelRayTracerBase(int screenWidth, int screenHeight)
            : base(screenWidth, screenHeight)
        {
            MaxDegreeOfParallelism = -1;    // No limit
        }

        public int MaxDegreeOfParallelism { get; set; }
        public CancellationToken CancellationToken { get; set; }

        public sealed override void Render(Scene scene, Int32[] rgbBuffer)
        {
            ParallelOptions parallelOpts = new ParallelOptions {
                MaxDegreeOfParallelism = MaxDegreeOfParallelism,
                CancellationToken = CancellationToken,
            };
            Render(scene, rgbBuffer, parallelOpts);
        }

        public abstract void Render(Scene scene, Int32[] rgbBuffer, ParallelOptions parallelOpts);

    }
}
